package uulm.teamname.marvelous.gamelibrary.entities;

import uulm.teamname.marvelous.gamelibrary.IntVector2;

/** Represents an infinity stone {@link Entity}. Can only exist on the map.
 */
public class InfinityStone extends Entity {
    /** The {@link StoneType} of the infinity stone.
     */
    public final StoneType type;

    /** Constructs a new {@link InfinityStone}.
     * @param id The {@link EntityID} of the stone.
     * @param position The position of the stone.
     * @param type The {@link StoneType} of the stone.
     */
    public InfinityStone(EntityID id, IntVector2 position, StoneType type) {
        super(id, position);
        this.type = type;
    }
}
